﻿float4x4 View;
float4x4 Projection;
float4x4 World;

bool AlphaTest = true;
bool AlphaTestGreater;
float AlphaTestValue = 0.5f;
float4 Color;

bool AdjustUV;
float2 MinUV;
float2 MaxUV;

texture ParticleTexture;
	sampler2D texSampler = sampler_state {
	texture = <ParticleTexture>;
};

struct VertexShaderInput
{
	float4 Position : POSITION0;
	float2 UV : TEXCOORD0;
};

struct VertexShaderOutput
{
	float4 Position : POSITION0;
	float2 UV : TEXCOORD0;
};

VertexShaderOutput VertexShaderFunction(VertexShaderInput input){
	VertexShaderOutput output;
	float4 worldPosition = mul(input.Position, World);
    float4 viewPosition = mul(worldPosition, View);
    output.Position = mul(viewPosition, Projection);
	if(AdjustUV){
		output.UV.x=input.UV.x==0?MinUV.x:MaxUV.x;
		output.UV.y=input.UV.y==0?MinUV.y:MaxUV.y;
	}
	else output.UV = input.UV;
	return output; 
}

float4 PixelShaderFunction(VertexShaderOutput input) : COLOR0{
	float4 color = tex2D(texSampler, input.UV);
	color.rgba*=Color.rgba;
	if (AlphaTest) clip((color.a - AlphaTestValue)* (AlphaTestGreater ? 1 : -1));
	if(AdjustUV)return color;
	return color;
}

technique Technique1{
	pass Pass1{
		VertexShader = compile vs_3_0 VertexShaderFunction();
		PixelShader = compile ps_3_0 PixelShaderFunction();
	}
}