﻿texture FadeTexture;
float intensity;

sampler2D texSampler = sampler_state {
texture = <FadeTexture>;
};

struct VertexShaderInput
{
    float4 Position : POSITION0;
	float2 UV: TEXCOORD0;
};

struct VertexShaderOutput
{
    float4 Position : POSITION0;
	float2 UV: TEXCOORD0;
};

VertexShaderOutput VertexShaderFunction(VertexShaderInput input)
{
    VertexShaderOutput output;
	output.Position=input.Position;
	output.UV=input.UV;
    return output;
}

float4 PixelShaderFunction(VertexShaderOutput input) : COLOR0
{
	float3 color=tex2D(texSampler,input.UV);
    return float4((color*(1-intensity)), 1);
}

technique Technique1
{
    pass Pass1
    {
        VertexShader = compile vs_2_0 VertexShaderFunction();
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}
